html 
    head 
        style 
            include ../public/css/index.css

        title Security Lab 

    body

        div(class="navigation")
            ul(class="nav-list")
                li(class="nav-item"): a(href="/" class="nav-link") HOME 
                li(class="nav-item"): a(href="/csrf" class="nav-link") CSRF
                if(username) 
                    li(class="nav-item"): form(action="/logout" method="post" id="logout-form")
                        input(type="submit" value="LOGOUT" id="logout-button") 
                        if(token)
                            input(type="hidden" name="token" value=token)
                else 
                    li(class="nav-item"): a(href="/login" class="nav-link") LOGIN


        h1(class="main-page-title") Sigurnost
        p(class="description") Tema ove laboratorijske vježbe bila je implementirati SQL umetanje (SQL Injection) i lažiranje zahtjeva na drugom sjedištu (Cross Site Request Forgery, CSRF).

        hr(class="divider")

        h3(class="section-title") CSRF 
        p(class="description") Kako biste testirali CSRF ranjivost, potrebno je ulogirati se s postojećim korisničkim računom (više info na stranici za login) te otvoriti stranicu za CSRF.
        p(class="description") Sljedeće, potrebno je kliknuti na link koji će otvoriti aplikaciju na drugom sjedištu koja će u pozadini izvesti CSRF, odnosno poslati će POST zahtjev za odjavu prijavljenog korisnika na /logout endpoint. Aplikacija koristi cookie za autentifikaciju korisnika.
        p(class="description") Na CSRF stranici se također pomoću checkbox-a i gumba za spremanje omogućuje ili onemogućuje CSRF. Onemogućavanjem CSRF-a, provjerava se ispravnost tokena generiranog prilikom prijave korisnika. Token se šalje kao dio forme prilikom pritiska korisnika na gumb za odjavu.

        hr(class="divider")

        h3(class="section-title") SQL injection
        p(class="description") Ovdje možete testirati ranjivost SQL.
        p(class="description") 
            b  Upute: 
            .
              Korisnik upisuje korisničko ime i lozinku, te ukoliko su oni ispravni, aplikacija ispisuje sve podatke o navedenom korisniku. Primjer ispravnih korisničkih podataka - 
            b username: 
            .
              admin, 
            b password: 
            .
             password

        p(class="description") Uključivanjem ranjivosti omogućavaju se sve vrste SQL umetanja. Primjerice upisom izraza 
            span(style="background-color:#666; color:#ffffff") ' OR TRUE--
            | 
            .
              (tautologija) aplikacija ispisuje sve podatke svih korisnika u bazi.


        div(id="form-container")

            if(error)
                div(id="error-message")
                    p #{error}

            form(action="/", method="post")
                div(class="input-field")
                    label(for="vulnerability-enabled") Omogući SQL umetanje: 
                    input#vulnerability-enabled(type="checkbox", name="vulnerability-enabled")
                div(class="input-field")
                    label(for="username") Username: 
                    input(type="text" name="username") 
                div(class="input-field")
                    label(for="password") Password: 
                    input(type="password" name="password") 
                div(class="input-field")
                    input(type="submit", value="Submit")

        if(results)
            - let users = JSON.parse(results)
            
            div(id="results")
                table(class="users-table")
                    tr(class="users-table-row")
                        th(class="users-table-header") Username 
                        th(class="users-table-header") Password
                        th(class="users-table-header") First name
                        th(class="users-table-header") Last name
                        th(class="users-table-header") Email 
                        th(class="users-table-header") Year of birth

                    each user in users 
                        tr(class="users-table-row") 
                            td(class="users-table-data") #{user.username}
                            td(class="users-table-data") #{user.password}
                            td(class="users-table-data") #{user.first_name}
                            td(class="users-table-data") #{user.last_name}
                            td(class="users-table-data") #{user.email}
                            td(class="users-table-data") #{user.year_of_birth}
